FLTK 1.3.2

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Public Attributes | Protected Member Functions
Fl_Browser_ Class Reference

This is the base class for browsers. More...

`#include <Fl_Browser_.H>`

Inheritance diagram for Fl_Browser_:

List of all members.

## Public Types
enum | { HORIZONTAL = 1, VERTICAL = 2, BOTH = 3, ALWAYS_ON = 4, HORIZONTAL_ALWAYS = 5, VERTICAL_ALWAYS = 6, BOTH_ALWAYS = 7 }
| Values for has_scrollbar(). More...
## Public Member Functions
int | deselect (int docallbacks=0)
| Deselects all items in the list and returns 1 if the state changed or 0 if it did not.
void | display (void *item)
| Displays the `item`, scrolling the list as necessary.
int | handle (int event)
| Handles the `event` within the normal widget bounding box.
uchar | has_scrollbar () const
| Returns the current scrollbar mode, see Fl_Browser_::has_scrollbar(uchar)
void | has_scrollbar (uchar mode)
| Sets whether the widget should have scrollbars or not (default Fl_Browser_::BOTH).
int | hposition () const
| Gets the horizontal scroll position of the list as a pixel position `pos`.
void | hposition (int)
| Sets the horizontal scroll position of the list to pixel position `pos`.
int | position () const
| Gets the vertical scroll position of the list as a pixel position `pos`.
void | position (int pos)
| Sets the vertical scroll position of the list to pixel position `pos`.
void | resize (int X, int Y, int W, int H)
| Repositions and/or resizes the browser.
void | scrollbar_left ()
| Moves the vertical scrollbar to the lefthand side of the list.
void | scrollbar_right ()
| Moves the vertical scrollbar to the righthand side of the list.
int | scrollbar_size () const
| Gets the current size of the scrollbars' troughs, in pixels.
void | scrollbar_size (int newSize)
| Sets the pixel size of the scrollbars' troughs to `newSize`, in pixels.
int | scrollbar_width () const
| This method has been deprecated, existing for backwards compatibility only.
void | scrollbar_width (int width)
| This method has been deprecated, existing for backwards compatibility only.
int | select (void *item, int val=1, int docallbacks=0)
| Sets the selection state of `item` to `val`, and returns 1 if the state changed or 0 if it did not.
int | select_only (void *item, int docallbacks=0)
| Selects `item` and returns 1 if the state changed or 0 if it did not.
void | sort (int flags=0)
| Sort the items in the browser based on `flags`.
Fl_Color | textcolor () const
| Gets the default text color for the lines in the browser.
void | textcolor (Fl_Color col)
| Sets the default text color for the lines in the browser to color `col`.
Fl_Font | textfont () const
| Gets the default text font for the lines in the browser.
void | textfont (Fl_Font font)
| Sets the default text font for the lines in the browser to `font`.
Fl_Fontsize | textsize () const
| Gets the default text size (in pixels) for the lines in the browser.
void | textsize (Fl_Fontsize newSize)
| Sets the default text size (in pixels) for the lines in the browser to `size`.
## Public Attributes
Fl_Scrollbar | hscrollbar
| Horizontal scrollbar.
Fl_Scrollbar | scrollbar
| Vertical scrollbar.
## Protected Member Functions
void | bbox (int &X, int &Y, int &W, int &H) const
| Returns the bounding box for the interior of the list's display window, inside the scrollbars.
void | deleting (void *item)
| This method should be used when `item` is being deleted from the list.
int | displayed (void *item) const
| Returns non-zero if `item` has been scrolled to a position where it is being displayed.
void | draw ()
| Draws the list within the normal widget bounding box.
void * | find_item (int ypos)
| This method returns the item under mouse y position `ypos`.
| Fl_Browser_ (int X, int Y, int W, int H, const char *L=0)
| The constructor makes an empty browser.
virtual int | full_height () const
| This method may be provided by the subclass to indicate the full height of the item list, in pixels.
virtual int | full_width () const
| This method may be provided by the subclass to indicate the full width of the item list, in pixels.
virtual int | incr_height () const
| This method may be provided to return the average height of all items to be used for scrolling.
void | inserting (void *a, void *b)
| This method should be used when an item is in the process of being inserted into the list.
virtual void * | item_at (int index) const
| This method must be provided by the subclass to return the item for the specified `index`.
virtual void | item_draw (void *item, int X, int Y, int W, int H) const =0
| This method must be provided by the subclass to draw the `item` in the area indicated by `X`, `Y`, `W`, `H`.
virtual void * | item_first () const =0
| This method must be provided by the subclass to return the first item in the list.
virtual int | item_height (void *item) const =0
| This method must be provided by the subclass to return the height of `item` in pixels.
virtual void * | item_last () const
| This method must be provided by the subclass to return the last item in the list.
virtual void * | item_next (void *item) const =0
| This method must be provided by the subclass to return the item in the list after `item`.
virtual void * | item_prev (void *item) const =0
| This method must be provided by the subclass to return the item in the list before `item`.
virtual int | item_quick_height (void *item) const
| This method may be provided by the subclass to return the height of the `item`, in pixels.
virtual void | item_select (void *item, int val=1)
| This method must be implemented by the subclass if it supports multiple selections; sets the selection state to `val` for the `item`.
virtual int | item_selected (void *item) const
| This method must be implemented by the subclass if it supports multiple selections; returns the selection state for `item`.
virtual void | item_swap (void *a, void *b)
| This optional method should be provided by the subclass to efficiently swap browser items `a` and `b`, such as for sorting.
virtual const char * | item_text (void *item) const
| This optional method returns a string (label) that may be used for sorting.
virtual int | item_width (void *item) const =0
| This method must be provided by the subclass to return the width of the `item` in pixels.
int | leftedge () const
| This method returns the X position of the left edge of the list area after adjusting for the scrollbar and border, if any.
void | new_list ()
| This method should be called when the list data is completely replaced or cleared.
void | redraw_line (void *item)
| This method should be called when the contents of `item` has changed, but not its height.
void | redraw_lines ()
| This method will cause the entire list to be redrawn.
void | replacing (void *a, void *b)
| This method should be used when item `a` is being replaced by item `b`.
void * | selection () const
| Returns the item currently selected, or NULL if there is no selection.
void | swapping (void *a, void *b)
| This method should be used when two items `a` and `b` are being swapped.
void * | top () const
| Returns the item that appears at the top of the list.

## Detailed Description

This is the base class for browsers.

To be useful it must be subclassed and several virtual functions defined. The Forms-compatible browser and the file chooser's browser are subclassed off of this.

This has been designed so that the subclass has complete control over the storage of the data, although because next() and prev() functions are used to index, it works best as a linked list or as a large block of characters in which the line breaks must be searched for.

A great deal of work has been done so that the "height" of a data object does not need to be determined until it is drawn. This is useful if actually figuring out the size of an object requires accessing image data or doing stat() on a file or doing some other slow operation.

## Member Enumeration Documentation

anonymous enum

Values for has_scrollbar().

Anonymous enum bit flags for has_scrollbar().

- bit 0: horizontal
- bit 1: vertical
- bit 2: 'always' (to be combined with bits 0 and 1)
- bit 3-31: reserved for future use

Enumerator:

  HORIZONTAL | Only show horizontal scrollbar.
  VERTICAL | Only show vertical scrollbar.
  BOTH | Show both scrollbars. (default)
  ALWAYS_ON | Specified scrollbar(s) should 'always' be shown (to be used with HORIZONTAL/VERTICAL)
  HORIZONTAL_ALWAYS | Horizontal scrollbar always on.
  VERTICAL_ALWAYS | Vertical scrollbar always on.
  BOTH_ALWAYS | Both scrollbars always on.

## Constructor & Destructor Documentation

Fl_Browser_::Fl_Browser_ | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | const char * | L = `0`
| ) |  | `[protected]`

The constructor makes an empty browser.

Parameters:

  [in] | X,Y,W,H | position and size.
  [in] | L | The label string, may be NULL.

## Member Function Documentation

void Fl_Browser_::bbox | ( | int & | X,
|  | int & | Y,
|  | int & | W,
|  | int & | H
| ) |  | const`[protected]`

Returns the bounding box for the interior of the list's display window, inside the scrollbars.

Parameters:

  [out] | X,Y,W,H | The returned bounding box. (The original contents of these parameters are overwritten)

void Fl_Browser_::deleting | ( | void * | item | ) | `[protected]`

This method should be used when `item` is being deleted from the list.

It allows the Fl_Browser_ to discard any cached data it has on the item. This method does not actually delete the item, but handles the follow up bookkeeping after the item has just been deleted.

Parameters:

  [in] | item | The item being deleted.

int Fl_Browser_::deselect | ( | int | docallbacks = `0` | ) |

Deselects all items in the list and returns 1 if the state changed or 0 if it did not.

If the optional `docallbacks` parameter is non-zero, deselect tries to call the callback function for the widget.

Parameters:

  [in] | docallbacks | If 1, invokes widget callback if item changed. If 0, doesn't do callback (default).

void Fl_Browser_::display | ( | void * | item | ) |

Displays the `item`, scrolling the list as necessary.

Parameters:

  [in] | item | The item to be displayed.

See also:
  display(), displayed()

int Fl_Browser_::displayed | ( | void * | item | ) | const`[protected]`

Returns non-zero if `item` has been scrolled to a position where it is being displayed.

Checks to see if the item's vertical position is within the top and bottom edges of the display window. This does NOT take into account the hide()/show() status of the widget or item.

Parameters:

  [in] | item | The item to check

Returns:
  1 if visible, 0 if not visible.

See also:
  display(), displayed()

void * Fl_Browser_::find_item | ( | int | ypos | ) | `[protected]`

This method returns the item under mouse y position `ypos`.

NULL is returned if no item is displayed at that position.

Parameters:

  [in] | ypos | The y position (eg. Fl::event_y()) to find an item under.

Returns:
  The item, or NULL if not found

int Fl_Browser_::full_height | ( |  | ) | const`[protected, virtual]`

This method may be provided by the subclass to indicate the full height of the item list, in pixels.

The default implementation computes the full height from the item heights. Includes the items that are scrolled off screen.

Returns:
  The height of the entire list, in pixels.

Reimplemented in Fl_Browser.

int Fl_Browser_::full_width | ( |  | ) | const`[protected, virtual]`

This method may be provided by the subclass to indicate the full width of the item list, in pixels.

The default implementation computes the full width from the item widths.

Returns:
  The maximum width of all the items, in pixels.

int Fl_Browser_::handle | ( | int | event | ) | `[virtual]`

Handles the `event` within the normal widget bounding box.

Parameters:

  [in] | event | The event to process.

Returns:
  1 if event was processed, 0 if not.

Reimplemented from Fl_Group.

Reimplemented in Fl_Check_Browser.

void Fl_Browser_::has_scrollbar | ( | uchar | mode | ) | `[inline]`

Sets whether the widget should have scrollbars or not (default Fl_Browser_::BOTH).

By default you can scroll in both directions, and the scrollbars disappear if the data will fit in the widget. has_scrollbar() changes this based on the value of `mode:`

- 0 - No scrollbars.

- Fl_Browser_::HORIZONTAL - Only a horizontal scrollbar.

- Fl_Browser_::VERTICAL - Only a vertical scrollbar.

- Fl_Browser_::BOTH - The default is both scrollbars.

- Fl_Browser_::HORIZONTAL_ALWAYS - Horizontal scrollbar always on, vertical always off.

- Fl_Browser_::VERTICAL_ALWAYS - Vertical scrollbar always on, horizontal always off.

- Fl_Browser_::BOTH_ALWAYS - Both always on.

int Fl_Browser_::hposition | ( |  | ) | const`[inline]`

Gets the horizontal scroll position of the list as a pixel position `pos`.

The position returned is how many pixels of the list are scrolled off the left edge of the screen. Example: A position of '18' indicates the left 18 pixels of the list are scrolled off the left edge of the screen.

See also:
  position(), hposition()

void Fl_Browser_::hposition | ( | int | pos | ) |

Sets the horizontal scroll position of the list to pixel position `pos`.

The position is how many pixels of the list are scrolled off the left edge of the screen. Example: A position of '18' scrolls the left 18 pixels of the list off the left edge of the screen.

Parameters:

  [in] | pos | The horizontal position (in pixels) to scroll the browser to.

See also:
  position(), hposition()

int Fl_Browser_::incr_height | ( |  | ) | const`[protected, virtual]`

This method may be provided to return the average height of all items to be used for scrolling.

The default implementation uses the height of the first item.

Returns:
  The average height of items, in pixels.

Reimplemented in Fl_Browser.

void Fl_Browser_::inserting | ( | void * | a,
|  | void * | b
| ) |  | `[protected]`

This method should be used when an item is in the process of being inserted into the list.

It allows the Fl_Browser_ to update its cache data as needed, scheduling a redraw for the affected lines. This method does not actually insert items, but handles the follow up bookkeeping after items have been inserted.

Parameters:

  [in] | a | The starting item position
  [in] | b | The new item being inserted

virtual void* Fl_Browser_::item_at | ( | int | index | ) | const`[inline, protected, virtual]`

This method must be provided by the subclass to return the item for the specified `index`.

Parameters:

  [in] | index | The `index` of the item to be returned

Returns:
  The item at the specified `index`.

Reimplemented in Fl_Browser.

virtual void* Fl_Browser_::item_first | ( |  | ) | const`[protected, pure virtual]`

This method must be provided by the subclass to return the first item in the list.

See also:
  item_first(), item_next(), item_last(), item_prev()

Implemented in Fl_Browser.

virtual int Fl_Browser_::item_height | ( | void * | item | ) | const`[protected, pure virtual]`

This method must be provided by the subclass to return the height of `item` in pixels.

Allow for two additional pixels for the list selection box.

Parameters:

  [in] | item | The item whose height is returned.

Returns:
  The height of the specified `item` in pixels.

See also:
  item_height(), item_width(), item_quick_height()

Implemented in Fl_Browser.

virtual void* Fl_Browser_::item_last | ( |  | ) | const`[inline, protected, virtual]`

This method must be provided by the subclass to return the last item in the list.

See also:
  item_first(), item_next(), item_last(), item_prev()

Reimplemented in Fl_Browser.

virtual void* Fl_Browser_::item_next | ( | void * | item | ) | const`[protected, pure virtual]`

This method must be provided by the subclass to return the item in the list after `item`.

See also:
  item_first(), item_next(), item_last(), item_prev()

Implemented in Fl_Browser.

virtual void* Fl_Browser_::item_prev | ( | void * | item | ) | const`[protected, pure virtual]`

This method must be provided by the subclass to return the item in the list before `item`.

See also:
  item_first(), item_next(), item_last(), item_prev()

Implemented in Fl_Browser.

int Fl_Browser_::item_quick_height | ( | void * | item | ) | const`[protected, virtual]`

This method may be provided by the subclass to return the height of the `item`, in pixels.

Allow for two additional pixels for the list selection box. This method differs from item_height in that it is only called for selection and scrolling operations. The default implementation calls item_height.

Parameters:

  [in] | item | The item whose height to return.

Returns:
  The height, in pixels.

void Fl_Browser_::item_select | ( | void * | item,
|  | int | val = `1`
| ) |  | `[protected, virtual]`

This method must be implemented by the subclass if it supports multiple selections; sets the selection state to `val` for the `item`.

Sets the selection state for `item`, where optional `val` is 1 (select, the default) or 0 (de-select).

Parameters:

  [in] | item | The item to be selected
  [in] | val | The optional selection state; 1=select, 0=de-select. The default is to select the item (1).

Reimplemented in Fl_Browser.

int Fl_Browser_::item_selected | ( | void * | item | ) | const`[protected, virtual]`

This method must be implemented by the subclass if it supports multiple selections; returns the selection state for `item`.

The method should return 1 if `item` is selected, or 0 otherwise.

Parameters:

  [in] | item | The item to test.

Reimplemented in Fl_Browser.

virtual void Fl_Browser_::item_swap | ( | void * | a,
|  | void * | b
| ) |  | `[inline, protected, virtual]`

This optional method should be provided by the subclass to efficiently swap browser items `a` and `b`, such as for sorting.

Parameters:

  [in] | a,b | The two items to be swapped.

Reimplemented in Fl_Browser.

virtual const char* Fl_Browser_::item_text | ( | void * | item | ) | const`[inline, protected, virtual]`

This optional method returns a string (label) that may be used for sorting.

Parameters:

  [in] | item | The item whose label text is returned.

Returns:
  The item's text label. (Can be NULL if blank)

Reimplemented in Fl_Browser.

virtual int Fl_Browser_::item_width | ( | void * | item | ) | const`[protected, pure virtual]`

This method must be provided by the subclass to return the width of the `item` in pixels.

Allow for two additional pixels for the list selection box.

Parameters:

  [in] | item | The item whose width is returned.

Returns:
  The width of the item in pixels.

Implemented in Fl_Browser.

int Fl_Browser_::leftedge | ( |  | ) | const`[protected]`

This method returns the X position of the left edge of the list area after adjusting for the scrollbar and border, if any.

Returns:
  The X position of the left edge of the list, in pixels.

See also:
  Fl_Browser_::bbox()

void Fl_Browser_::new_list | ( |  | ) | `[protected]`

This method should be called when the list data is completely replaced or cleared.

It informs the Fl_Browser_ widget that any cached information it has concerning the items is invalid. This method does not clear the list, it just handles the follow up bookkeeping after the list has been cleared.

int Fl_Browser_::position | ( |  | ) | const`[inline]`

Gets the vertical scroll position of the list as a pixel position `pos`.

The position returned is how many pixels of the list are scrolled off the top edge of the screen. Example: A position of '3' indicates the top 3 pixels of the list are scrolled off the top edge of the screen.

See also:
  position(), hposition()

void Fl_Browser_::position | ( | int | pos | ) |

Sets the vertical scroll position of the list to pixel position `pos`.

The position is how many pixels of the list are scrolled off the top edge of the screen. Example: A position of '3' scrolls the top three pixels of the list off the top edge of the screen.

Parameters:

  [in] | pos | The vertical position (in pixels) to scroll the browser to.

See also:
  position(), hposition()

void Fl_Browser_::redraw_line | ( | void * | item | ) | `[protected]`

This method should be called when the contents of `item` has changed, but not its height.

Parameters:

  [in] | item | The item that needs to be redrawn.

See also:
  redraw_lines(), redraw_line()

void Fl_Browser_::redraw_lines | ( |  | ) | `[inline, protected]`

This method will cause the entire list to be redrawn.

See also:
  redraw_lines(), redraw_line()

void Fl_Browser_::replacing | ( | void * | a,
|  | void * | b
| ) |  | `[protected]`

This method should be used when item `a` is being replaced by item `b`.

It allows the Fl_Browser_ to update its cache data as needed, schedules a redraw for the item being changed, and tries to maintain the selection. This method does not actually replace the item, but handles the follow up bookkeeping after the item has just been replaced.

Parameters:

  [in] | a | Item being replaced
  [in] | b | Item to replace 'a'

void Fl_Browser_::resize | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H
| ) |  | `[virtual]`

Repositions and/or resizes the browser.

Parameters:

  [in] | X,Y,W,H | The new position and size for the browser, in pixels.

Reimplemented from Fl_Group.

void Fl_Browser_::scrollbar_left | ( |  | ) | `[inline]`

Moves the vertical scrollbar to the lefthand side of the list.

For back compatibility.

void Fl_Browser_::scrollbar_right | ( |  | ) | `[inline]`

Moves the vertical scrollbar to the righthand side of the list.

For back compatibility.

int Fl_Browser_::scrollbar_size | ( |  | ) | const`[inline]`

Gets the current size of the scrollbars' troughs, in pixels.

If this value is zero (default), this widget will use the Fl::scrollbar_size() value as the scrollbar's width.

Returns:
  Scrollbar size in pixels, or 0 if the global Fl::scrollsize() is being used.

See also:
  Fl::scrollbar_size(int)

void Fl_Browser_::scrollbar_size | ( | int | newSize | ) | `[inline]`

Sets the pixel size of the scrollbars' troughs to `newSize`, in pixels.

Normally you should not need this method, and should use Fl::scrollbar_size(int) instead to manage the size of ALL your widgets' scrollbars. This ensures your application has a consistent UI, is the default behavior, and is normally what you want.

Only use THIS method if you really need to override the global scrollbar size. The need for this should be rare.

Setting `newSize` to the special value of 0 causes the widget to track the global Fl::scrollbar_size(), which is the default.

Parameters:

  [in] | newSize | Sets the scrollbar size in pixels. If 0 (default), scrollbar size tracks the global Fl::scrollbar_size()

See also:
  Fl::scrollbar_size()

int Fl_Browser_::scrollbar_width | ( |  | ) | const`[inline]`

This method has been deprecated, existing for backwards compatibility only.

Use scrollbar_size() instead. This method always returns the global value Fl::scrollbar_size().

Returns:
  Always returns the global value Fl::scrollbar_size().

Todo:
  This method should eventually be removed in 1.4+

void Fl_Browser_::scrollbar_width | ( | int | width | ) | `[inline]`

This method has been deprecated, existing for backwards compatibility only.

Use scrollbar_size(int) instead. This method sets the global Fl::scrollbar_size(), and forces this instance of the widget to use it.

Todo:
  This method should eventually be removed in 1.4+

int Fl_Browser_::select | ( | void * | item,
|  | int | val = `1`,
|  | int | docallbacks = `0`
| ) |  |

Sets the selection state of `item` to `val`, and returns 1 if the state changed or 0 if it did not.

If `docallbacks` is non-zero, select tries to call the callback function for the widget.

Parameters:

  [in] | item | The item whose selection state is to be changed
  [in] | val | The new selection state (1=select, 0=de-select)
  [in] | docallbacks | If 1, invokes widget callback if item changed. If 0, doesn't do callback (default).

Returns:
  1 if state was changed, 0 if not.

int Fl_Browser_::select_only | ( | void * | item,
|  | int | docallbacks = `0`
| ) |  |

Selects `item` and returns 1 if the state changed or 0 if it did not.

Any other items in the list are deselected.

Parameters:

  [in] | item | The `item` to select.
  [in] | docallbacks | If 1, invokes widget callback if item changed. If 0, doesn't do callback (default).

void* Fl_Browser_::selection | ( |  | ) | const`[inline, protected]`

Returns the item currently selected, or NULL if there is no selection.

For multiple selection browsers this call returns the currently focused item, even if it is not selected. To find all selected items, call Fl_Multi_Browser::selected() for every item in question.

void Fl_Browser_::sort | ( | int | flags = `0` | ) |

Sort the items in the browser based on `flags`.

item_swap(void*, void*) and item_text(void*) must be implemented for this call.

Parameters:

  [in] | flags | FL_SORT_ASCENDING -- sort in ascending order FL_SORT_DESCENDING -- sort in descending order Values other than the above will cause undefined behavior Other flags may appear in the future.

Todo:
  Add a flag to ignore case

void Fl_Browser_::swapping | ( | void * | a,
|  | void * | b
| ) |  | `[protected]`

This method should be used when two items `a` and `b` are being swapped.

It allows the Fl_Browser_ to update its cache data as needed, schedules a redraw for the two items, and tries to maintain the current selection. This method does not actually swap items, but handles the follow up bookkeeping after items have been swapped.

Parameters:

  [in] | a,b | Items being swapped.

Fl_Font Fl_Browser_::textfont | ( |  | ) | const`[inline]`

Gets the default text font for the lines in the browser.

See also:
  textfont(), textsize(), textcolor()

## Member Data Documentation

Fl_Scrollbar Fl_Browser_::hscrollbar

Horizontal scrollbar.

Public, so that it can be accessed directly.

Fl_Scrollbar Fl_Browser_::scrollbar

Vertical scrollbar.

Public, so that it can be accessed directly.

The documentation for this class was generated from the following files:

- Fl_Browser_.H
- Fl_Browser_.cxx